<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Api\Data;

/**
 * Speedy Order interface.
 * @api
 */
interface OrderInterface
{
    /**
     * Constants for keys of data array. Identical to the name of the getter in snake case
     */
    const ID                            = 'speedy_order_id';
    const SPEEDY_ORDER_ID               = 'speedy_order_id';
    const ORDER_ID                      = 'order_id';
    const BOL_ID                        = 'bol_id';
    const DATA                          = 'data';
    const DATE_CREATED                  = 'date_created';
    const COURIER                       = 'courier';

    /**#@-*/

    /**
     * Get ID
     *
     * @return int
     */
    public function getId();

    /**
     * Get speedy order id
     *
     * @return int
     */
    public function getSpeedyOrderId();

    /**
     * Get order id
     *
     * @return int
     */
    public function getOrderId();

    /**
     * Get tovaritelnica
     *
     * @return string
     */
    public function getBolId();

    /**
     * Get data
     *
     * @return string
     */
    public function getDataColumn();

    /**
     * Get date_created
     *
     * @return string
     */
    public function getDateCreated();

    /**
     * Get courier
     *
     * @return int
     */
    public function getCourier();

    /**
     * Set ID
     *
     * @param int $id
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setId($id);

    /**
     * Set speedy order id
     *
     * @param int $speedyOrderId
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setSpeedyOrderId($speedyOrderId);

    /**
     * Set order id
     *
     * @param int $orderId
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setOrderId($orderId);

    /**
     * Set bol id
     *
     * @param string $bolId
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setBolId($bolId);

    /**
     * Set data
     *
     * @param string $data
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setDataColumn($data);

    /**
     * Set date created
     *
     * @param string $dateCreated
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setDateCreated($dateCreated);

    /**
     * Set courier
     *
     * @param string $courier
     * @return \Extensa\Speedy\Api\Data\OrderInterface
     */
    public function setCourier($courier);
}
