<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Api\Data;

/**
 * Speedy Table Rate interface.
 * @api
 */
interface TablerateInterface
{
    /**
     * Constants for keys of data array. Identical to the name of the getter in snake case
     */
    const ID                            = 'table_rate_id';
    const TABLE_RATE_ID                 = 'table_rate_id';
    const SERVICE_ID                    = 'service_id';
    const TAKE_FROM_OFFICE              = 'take_from_office';
    const WEIGHT                        = 'weight';
    const ORDER_TOTAL                   = 'order_total';
    const PRICE_WITHOUT_VAT             = 'price_without_vat';
    const FIXED_TIME_DELIVERY           = 'fixed_time_delivery';

    /**#@-*/

    /**
     * Get ID
     *
     * @return int
     */
    public function getId();

    /**
     * Get Table Rate ID
     *
     * @return int
     */
    public function getTableRateId();

    /**
     * Get Service ID
     *
     * @return int
     */
    public function getServiceId();

    /**
     * Get Take From Office
     *
     * @return int
     */
    public function getTakeFromOffice();

    /**
     * Get Weight
     *
     * @return string
     */
    public function getWeight();

    /**
     * Get Order Total
     *
     * @return string
     */
    public function getOrderTotal();

    /**
     * Get Price Without Vat
     *
     * @return string
     */
    public function getPriceWithoutVat();

    /**
     * Get Fixed Time Delivery
     *
     * @return int
     */
    public function getFixedTimeDelivery();

    /**
     * Set ID
     *
     * @param int $id
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setId($id);

    /**
     * Set Table Rate ID
     *
     * @param int $tableRateId
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setTableRateId($tableRateId);

    /**
     * Set Service ID
     *
     * @param int $serviceId
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setServiceId($serviceId);

    /**
     * Set Take From Office
     *
     * @param int $takeFromOffice
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setTakeFromOffice($takeFromOffice);

    /**
     * Set weight
     *
     * @param string $weight
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setWeight($weight);

    /**
     * Set Order Total
     *
     * @param string $orderTotal
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setOrderTotal($orderTotal);

    /**
     * Set Price Without Vat
     *
     * @param string $priceWithoutVat
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setPriceWithoutVat($priceWithoutVat);

    /**
     * Set Fixed Time Delivery
     *
     * @param int $fixedTimeDelivery
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setFixedTimeDelivery($fixedTimeDelivery);
}
