<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Api;

/**
 * Table rate CRUD interface.
 * @api
 */
interface TablerateRepositoryInterface
{
    /**
     * Save Table Rate.
     *
     * @param \Extensa\Speedy\Api\Data\TablerateInterface $tableRate
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function save(\Extensa\Speedy\Api\Data\TablerateInterface $tableRate);

    /**
     * Retrieve Table Rate.
     *
     * @param int $tableRateId
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     */
    public function getById($tableRateId);

    /**
     * Retrieve Tablerate matching the specified criteria.
     *
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Extensa\Speedy\Api\Data\AddressSearchResultsInterface
     */
    public function getList(\Magento\Framework\Api\SearchCriteriaInterface $searchCriteria);

    /**
     * Retrieve the first Tablerate matching the specified criteria.
     *
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \Extensa\Speedy\Api\Data\AddressSearchResultsInterface
     */
    public function getFirstResult(\Magento\Framework\Api\SearchCriteriaInterface $searchCriteria);
}
