<?php
namespace Extensa\Speedy\Block\Adminhtml\Sales\Order\View\Tab\Create;

class Parcelsize extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray
{
    /**
     * @var \Magento\Framework\ObjectManagerInterface
     */
    protected $objectManager;

    /**
     * Constructor
     * @param \Magento\Framework\ObjectManagerInterface $objectManager
     */
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\Framework\ObjectManagerInterface $objectManager,
        array $data = array()
    ) {
        $this->objectManager = $objectManager;

        parent::__construct($context, $data);

        $this->setHtmlId('_parcelsize');
    }

    protected function _prepareToRender()
    {
        $this->addColumn('width', array(
            'label' => __('Width'),
            'size' => 6,
            'style' => 'width: 95%;',
        ));
        $this->addColumn('height', array(
            'label' => __('Height'),
            'size' => 6,
            'style' => 'width: 95%;',
        ));
        $this->addColumn('depth', array(
            'label' => __('Depth'),
            'size' => 6,
            'style' => 'width: 95%;',
        ));
        $this->addColumn('weight', array(
            'label' => __('Weight'),
            'size' => 6,
            'style' => 'width: 95%;',
        ));

        $this->_addAfter = false;
        $this->_addButtonLabel = __('Add');
    }

    protected function _toHtml()
    {
        $form = $this->objectManager->create('Magento\Framework\Data\Form');
        $form->setHtmlIdPrefix('group_extensa_speedy');

        $element = $this->objectManager->create('Magento\Framework\Data\Form\Element\Text');
        $element->setName("extensa_speedy[parcels_size]");
        $element->setForm($form);

        if (!empty($this->getValue())) {
            $rows = array();

            foreach ($this->getValue() as $key => $row) {
                if (!empty($row)) {
                    $rows[$key] = array(
                        'width'           => $row['width'],
                        'height'          => $row['height'],
                        'depth'           => $row['depth'],
                        'weight'          => $row['weight'],
                        '_id'             => $key,
                    );
                }
            }

            $element->setValue($rows);
        }

        $this->setElement($element);

        return parent::_toHtml();
    }
}