<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Block\Adminhtml\System\Config\Form\Field\FieldArray;

use Magento\Backend\Block\Template\Context;

class Weightdimention extends \Magento\Config\Block\System\Config\Form\Field\FieldArray\AbstractFieldArray
{
    /**
     * @var \Extensa\Speedy\Helper\Data
     */
    protected $dataHelper;

    /**
     * Serviceslabels constructor.
     * @param Context $context
     * @param \Extensa\Speedy\Helper\Data $dataHelper
     * @param array $data
     */
    public function __construct(
        Context $context,
        \Extensa\Speedy\Helper\Data $dataHelper,
        array $data = []
    ) {
        $this->dataHelper = $dataHelper;

        parent::__construct($context, $data);
    }

    /**
     * Prepare to render
     *
     * @return void
     */
    protected function _prepareToRender()
    {
        $parcelSizes = $this->dataHelper->getParcelSizeList();

        $this->addColumn(
            'WEIGHT', ['label' => __('Package weight')]
        );

        foreach ($parcelSizes as $size) {
            $this->addColumn(
                $size['size'], ['label' => __('%1 <br/> (%2 x %3 x %4)', $size['size'], $size['height'], $size['width'] ,$size['depth'])]
            );
        }

        $this->_addAfter = false;
    }
}
