<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Controller\Adminhtml\Order;

use Extensa\Speedy\Controller\Adminhtml\Order;

class Cancel extends Order
{
    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $speedyOrder = $this->_initSpeedyOrder();

        if ($speedyOrder) {
            if ($speedyOrder->getBolId()) {
                $this->speedyHelper->cancelBol($speedyOrder->getBolId());

                if (!$this->speedyHelper->getError()) {
                    $speedyOrder->setBolId('')
                        ->setDateCreated('0000-00-00 00:00:00')
                        ->setCourier(0);

                    $this->speedyOrderRepository->save($speedyOrder);

                    $this->messageManager->addSuccessMessage(__('Success: You have cancelled Bill of Lading!'));
                } else {
                    $this->messageManager->addErrorMessage($this->speedyHelper->getError());
                }
            } else {
                $this->messageManager->addErrorMessage(__('Bill of lading already cancelled.'));
            }
        } else {
            $this->messageManager->addErrorMessage(__('This bill of lading no longer exists.'));
        }

        return $this->_redirect($this->_redirect->getRefererUrl());
    }
}
