<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Controller\Adminhtml\Order;

use Extensa\Speedy\Controller\Adminhtml\Order;

class Track extends Order
{
    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $speedyOrder = $this->_initSpeedyOrder();

        if ($speedyOrder) {
            return $this->_redirect(\Extensa\Speedy\Helper\Speedy::TRACKING_URL . $speedyOrder->getBolId(),[]);
        } else {
            $this->messageManager->addErrorMessage(__('This bill of lading no longer exists.'));

            return $resultPage->setData([
                'success'        => false,
                'ajaxExpired'    => true,
                'ajaxRedirect'   => $this->getRefreshUrl(),
            ]);
        }
    }
}
