<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model;

use Magento\Framework\Model\AbstractModel;
use Extensa\Speedy\Api\Data\AddressInterface;

class Address extends AbstractModel implements AddressInterface
{
    protected function _construct()
    {
        $this->_init('Extensa\Speedy\Model\ResourceModel\Address', 'address_id');
    }

    /**
     * Get ID
     *
     * @return int
     */
    public function getId()
    {
        return $this->getData(self::ID);
    }

    /**
     * @return mixed
     */
    public function getAddressId()
    {
        return $this->getData(self::ADDRESS_ID);
    }

    /**
     * @return mixed
     */
    public function getCustomerId()
    {
        return $this->getData(self::CUSTOMER_ID);
    }

    /**
     * @return mixed
     */
    public function getPostcode()
    {
        return $this->getData(self::POSTCODE);
    }

    /**
     * @return mixed
     */
    public function getRequiredPostcode()
    {
        return $this->getData(self::REQUIRED_POSTCODE);
    }

    /**
     * @return mixed
     */
    public function getCountry()
    {
        return $this->getData(self::COUNTRY);
    }

    /**
     * @return mixed
     */
    public function getCountryId()
    {
        return $this->getData(self::COUNTRY_ID);
    }

    /**
     * @return mixed
     */
    public function getCountryNomenclature()
    {
        return $this->getData(self::COUNTRY_NOMENCLATURE);
    }

    /**
     * @return mixed
     */
    public function getAbroad()
    {
        return $this->getData(self::ABROAD);
    }

    /**
     * @return mixed
     */
    public function getState()
    {
        return $this->getData(self::STATE);
    }

    /**
     * @return mixed
     */
    public function getStateId()
    {
        return $this->getData(self::STATE_ID);
    }

    /**
     * @return mixed
     */
    public function getRequiredState()
    {
        return $this->getData(self::REQUIRED_STATE);
    }

    /**
     * @return mixed
     */
    public function getCity()
    {
        return $this->getData(self::CITY);
    }

    /**
     * @return mixed
     */
    public function getCityId()
    {
        return $this->getData(self::CITY_ID);
    }

    /**
     * @return mixed
     */
    public function getCityNomenclature()
    {
        return $this->getData(self::CITY_NOMENCLATURE);
    }

    /**
     * @return mixed
     */
    public function getTakeOffice()
    {
        return $this->getData(self::TAKE_OFFICE);
    }

    /**
     * @return mixed
     */
    public function getOfficeId()
    {
        return $this->getData(self::OFFICE_ID);
    }

    /**
     * @return mixed
     */
    public function getQuarter()
    {
        return $this->getData(self::QUARTER);
    }

    /**
     * @return mixed
     */
    public function getQuarterId()
    {
        return $this->getData(self::QUARTER_ID);
    }

    /**
     * @return mixed
     */
    public function getStreet()
    {
        return $this->getData(self::STREET);
    }

    /**
     * @return mixed
     */
    public function getStreetId()
    {
        return $this->getData(self::STREET_ID);
    }

    /**
     * @return mixed
     */
    public function getStreetNo()
    {
        return $this->getData(self::STREET_NO);
    }

    /**
     * @return mixed
     */
    public function getBlockNo()
    {
        return $this->getData(self::BLOCK_NO);
    }

    /**
     * @return mixed
     */
    public function getEntranceNo()
    {
        return $this->getData(self::ENTRANCE_NO);
    }

    /**
     * @return mixed
     */
    public function getFloorNo()
    {
        return $this->getData(self::FLOOR_NO);
    }

    /**
     * @return mixed
     */
    public function getApartmentNo()
    {
        return $this->getData(self::APARTMENT_NO);
    }

    /**
     * @return mixed
     */
    public function getNote()
    {
        return $this->getData(self::NOTE);
    }

    /**
     * @return mixed
     */
    public function getAddress1()
    {
        return $this->getData(self::ADDRESS_1);
    }

    /**
     * @return mixed
     */
    public function getAddress2()
    {
        return $this->getData(self::ADDRESS_2);
    }

    /**
     * Set ID
     *
     * @param int $id
     * @return \Extensa\Speedy\Api\Data\AddressInterface
     */
    public function setId($id)
    {
        return $this->setData(self::ID, $id);
    }

    /**
     * @param int $addressId
     * @return mixed
     */
    public function setAddressId($addressId)
    {
        return $this->setData(self::ADDRESS_ID, $addressId);
    }

    /**
     * @param int $customerId
     * @return mixed
     */
    public function setCustomerId($customerId)
    {
        return $this->setData(self::CUSTOMER_ID, $customerId);
    }

    /**
     * @param string $postcode
     * @return mixed
     */
    public function setPostcode($postcode)
    {
        return $this->setData(self::POSTCODE, $postcode);
    }

    /**
     * @param int $requiredPostcode
     * @return mixed
     */
    public function setRequiredPostcode($requiredPostcode)
    {
        return $this->setData(self::REQUIRED_POSTCODE, $requiredPostcode);
    }

    /**
     * @param string $country
     * @return mixed
     */
    public function setCountry($country)
    {
        return $this->setData(self::COUNTRY, $country);
    }

    /**
     * @param int $countryId
     * @return mixed
     */
    public function setCountryId($countryId)
    {
        return $this->setData(self::COUNTRY_ID, $countryId);
    }

    /**
     * @param string $countryNomenclature
     * @return mixed
     */
    public function setCountryNomenclature($countryNomenclature)
    {
        return $this->setData(self::COUNTRY_NOMENCLATURE, $countryNomenclature);
    }

    /**
     * @param int $abroad
     * @return mixed
     */
    public function setAbroad($abroad)
    {
        return $this->setData(self::ABROAD, $abroad);
    }

    /**
     * @param string $state
     * @return mixed
     */
    public function setState($state)
    {
        return $this->setData(self::STATE, $state);
    }

    /**
     * @param int $stateId
     * @return mixed
     */
    public function setStateId($stateId)
    {
        return $this->setData(self::STATE_ID, $stateId);
    }

    /**
     * @param int $requiredState
     * @return mixed
     */
    public function setRequiredState($requiredState)
    {
        return $this->setData(self::REQUIRED_STATE, $requiredState);
    }

    /**
     * @param string $city
     * @return mixed
     */
    public function setCity($city)
    {
        return $this->setData(self::CITY, $city);
    }

    /**
     * @param int $cityId
     * @return mixed
     */
    public function setCityId($cityId)
    {
        return $this->setData(self::CITY_ID, $cityId);
    }

    /**
     * @param string $cityNomenclature
     * @return mixed
     */
    public function setCityNomenclature($cityNomenclature)
    {
        return $this->setData(self::CITY_NOMENCLATURE, $cityNomenclature);
    }

    /**
     * @param int $takeOffice
     * @return mixed
     */
    public function setTakeOffice($takeOffice)
    {
        return $this->setData(self::TAKE_OFFICE, $takeOffice);
    }

    /**
     * @param int $officeId
     * @return mixed
     */
    public function setOfficeId($officeId)
    {
        return $this->setData(self::OFFICE_ID, $officeId);
    }

    /**
     * @param string $quarter
     * @return mixed
     */
    public function setQuarter($quarter)
    {
        return $this->setData(self::QUARTER, $quarter);
    }

    /**
     * @param int $quarterId
     * @return mixed
     */
    public function setQuarterId($quarterId)
    {
        return $this->setData(self::QUARTER_ID, $quarterId);
    }

    /**
     * @param string $street
     * @return mixed
     */
    public function setStreet($street)
    {
        return $this->setData(self::STREET, $street);
    }

    /**
     * @param int $streetId
     * @return mixed
     */
    public function setStreetId($streetId)
    {
        return $this->setData(self::STREET_ID, $streetId);
    }

    /**
     * @param string $streetNo
     * @return mixed
     */
    public function setStreetNo($streetNo)
    {
        return $this->setData(self::STREET_NO, $streetNo);
    }

    /**
     * @param string $blockNo
     * @return mixed
     */
    public function setBlockNo($blockNo)
    {
        return $this->setData(self::BLOCK_NO, $blockNo);
    }

    /**
     * @param string $entranceNo
     * @return mixed
     */
    public function setEntranceNo($entranceNo)
    {
        return $this->setData(self::ENTRANCE_NO, $entranceNo);
    }

    /**
     * @param string $floorNo
     * @return mixed
     */
    public function setFloorNo($floorNo)
    {
        return $this->setData(self::FLOOR_NO, $floorNo);
    }

    /**
     * @param string $apartmentNo
     * @return mixed
     */
    public function setApartmentNo($apartmentNo)
    {
        return $this->setData(self::APARTMENT_NO, $apartmentNo);
    }

    /**
     * @param string $note
     * @return mixed
     */
    public function setNote($note)
    {
        return $this->setData(self::NOTE, $note);
    }

    /**
     * @param string $address_1
     * @return mixed
     */
    public function setAddress1($address_1)
    {
        return $this->setData(self::ADDRESS_1, $address_1);
    }

    /**
     * @param string $address_2
     * @return mixed
     */
    public function setAddress2($address_2)
    {
        return $this->setData(self::ADDRESS_2, $address_2);
    }
}
