<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model;

use Magento\Framework\Model\AbstractModel;
use Extensa\Speedy\Api\Data\OrderInterface;

class Order extends AbstractModel implements OrderInterface
{
    protected function _construct()
    {
        $this->_init('Extensa\Speedy\Model\ResourceModel\Order');
    }

    /**
     * Get ID
     *
     * @return int
     */
    public function getId()
    {
        return $this->getData(self::ID);
    }

    /**
     * @return mixed
     */
    public function getSpeedyOrderId()
    {
        return $this->getData(self::SPEEDY_ORDER_ID);
    }

    /**
     * @return mixed
     */
    public function getOrderId()
    {
        return $this->getData(self::ORDER_ID);
    }

    /**
     * @return mixed
     */
    public function getBolId()
    {
        return $this->getData(self::BOL_ID);
    }

    /**
     * @return mixed
     */
    public function getDataColumn()
    {
        return $this->getData(self::DATA);
    }

    /**
     * @return mixed
     */
    public function getDateCreated()
    {
        return $this->getData(self::DATE_CREATED);
    }

    /**
     * @return mixed
     */
    public function getCourier()
    {
        return $this->getData(self::COURIER);
    }

    /**
     * Set ID
     *
     * @param int $id
     * @return \Extensa\Speedy\Api\Data\CityInterface
     */
    public function setId($id)
    {
        return $this->setData(self::ID, $id);
    }

    /**
     * @param int $speedyOrderId
     * @return mixed
     */
    public function setSpeedyOrderId($speedyOrderId)
    {
        return $this->setData(self::SPEEDY_ORDER_ID, $speedyOrderId);
    }

    /**
     * @param int $orderId
     * @return mixed
     */
    public function setOrderId($orderId)
    {
        return $this->setData(self::ORDER_ID, $orderId);
    }

    /**
     * @param string $bolId
     * @return mixed
     */
    public function setBolId($bolId)
    {
        return $this->setData(self::BOL_ID, $bolId);
    }

    /**
     * @param string $data
     * @return mixed
     */
    public function setDataColumn($data)
    {
        return $this->setData(self::DATA, $data);
    }

    /**
     * @param string $dateCreated
     * @return mixed
     */
    public function setDateCreated($dateCreated)
    {
        return $this->setData(self::DATE_CREATED, $dateCreated);
    }

    /**
     * @param string $courier
     * @return mixed
     */
    public function setCourier($courier)
    {
        return $this->setData(self::COURIER, $courier);
    }


}
