<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model\ResourceModel\Order;

class Collection extends \Magento\Framework\Model\ResourceModel\Db\Collection\AbstractCollection
{
    /**
     * Define main table
     */
    protected function _construct()
    {
        $this->_init(
            'Extensa\Speedy\Model\Order',
            'Extensa\Speedy\Model\ResourceModel\Order'
        );
    }

    /**
     * @return \Extensa\Speedy\Model\ResourceModel\Order\Collection
     */
    public function addSalesOrder()
    {
        $this->getSelect()
            ->joinInner(
                array('sog' => $this->getTable('sales_order_grid')),
                'main_table.order_id = sog.entity_id',
                array(
                    'increment_id',
                    'shipping_name',
                    'billing_name',
                    'status'
                )
            );
        return $this;
    }

    /**
     * @return \Extensa\Speedy\Model\ResourceModel\Order\Collection
     */
    public function addBolFilter()
    {
        $this->getSelect()
            ->where('main_table.bol_id > 0');
        return $this;
    }
}
