<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model\System\Config\Source;

class Client implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var \Extensa\Speedy\Helper\Speedy
     */
    protected $speedyHelper;

    /**
     * Client constructor.
     * @param \Extensa\Speedy\Helper\Speedy $speedyHelper
     */
    public function __construct(
        \Extensa\Speedy\Helper\Speedy $speedyHelper
    ) {
        $this->speedyHelper = $speedyHelper;
    }

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $arr = array();

        $clients = $this->speedyHelper->getListContractClients();

        foreach ($clients as $client_id => $client) {
            $arr[] = array(
                'value' => $client_id,
                'label' => __('ID: %1, Name: %2, Address: %3', $client_id, $client['name'], $client['address'])
            );
        }

        return $arr;
    }
}
