<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model\System\Config\Source;

class Office implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var \Extensa\Speedy\Helper\Speedy
     */
    protected $speedyHelper;

    /**
     * Office constructor.
     * @param \Extensa\Speedy\Helper\Speedy $speedyHelper
     */
    public function __construct(
        \Extensa\Speedy\Helper\Speedy $speedyHelper
    ) {
        $this->speedyHelper = $speedyHelper;
    }

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $arr = array();

        $offices = $this->speedyHelper->getOffices();

        foreach ($offices as $office_id => $office) {
            $arr[] = array(
                'value' => $office_id,
                'label' => $office['label']
            );
        }

        return $arr;
    }
}
