<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model\System\Config\Source;

class Service implements \Magento\Framework\Option\ArrayInterface
{
    /**
     * @var \Extensa\Speedy\Helper\Speedy
     */
    protected $speedyHelper;

    /**
     * Service constructor.
     * @param \Extensa\Speedy\Helper\Speedy $speedyHelper
     */
    public function __construct(
        \Extensa\Speedy\Helper\Speedy $speedyHelper
    ) {
        $this->speedyHelper = $speedyHelper;
    }

    /**
     * Options getter
     *
     * @return array
     */
    public function toOptionArray()
    {
        $arr = array();

        $services = $this->speedyHelper->getServices();

        foreach ($services as $service_id => $service) {
            $arr[] = array(
                'value' => $service_id,
                'label' => $service . __(' (Service ID: %1)', $service_id)
            );
        }

        return $arr;
    }
}
