<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Model;

use Magento\Framework\Model\AbstractModel;
use Extensa\Speedy\Api\Data\TablerateInterface;

class Tablerate extends AbstractModel implements TablerateInterface
{
    protected function _construct()
    {
        $this->_init('Extensa\Speedy\Model\ResourceModel\Tablerate', 'table_rate_id');
    }

    /**
     * Get ID
     *
     * @return int
     */
    public function getId()
    {
        return $this->getData(self::TABLE_RATE_ID);
    }

    /**
     * @return mixed
     */
    public function getTableRateId()
    {
        return $this->getData(self::TABLE_RATE_ID);
    }

    /**
     * @return mixed
     */
    public function getServiceId()
    {
        return $this->getData(self::SERVICE_ID);
    }

    /**
     * @return mixed
     */
    public function getTakeFromOffice()
    {
        return $this->getData(self::TAKE_FROM_OFFICE);
    }

    /**
     * @return mixed
     */
    public function getWeight()
    {
        return $this->getData(self::WEIGHT);
    }

    /**
     * @return mixed
     */
    public function getOrderTotal()
    {
        return $this->getData(self::ORDER_TOTAL);
    }

    /**
     * @return mixed
     */
    public function getPriceWithoutVat()
    {
        return $this->getData(self::PRICE_WITHOUT_VAT);
    }

    /**
     * @return mixed
     */
    public function getFixedTimeDelivery()
    {
        return $this->getData(self::FIXED_TIME_DELIVERY);
    }

    /**
     * Set ID
     *
     * @param int $id
     * @return \Extensa\Speedy\Api\Data\TablerateInterface
     */
    public function setId($id)
    {
        return $this->setData(self::TABLE_RATE_ID, $id);
    }

    /**
     * @param int $tableRateId
     * @return mixed
     */
    public function setTableRateId($tableRateId)
    {
        return $this->setData(self::TABLE_RATE_ID, $tableRateId);
    }

    /**
     * @param int $serviceId
     * @return mixed
     */
    public function setServiceId($serviceId)
    {
        return $this->setData(self::SERVICE_ID, $serviceId);
    }

    /**
     * @param int $takeFromOffice
     * @return mixed
     */
    public function setTakeFromOffice($takeFromOffice)
    {
        return $this->setData(self::TAKE_FROM_OFFICE, $takeFromOffice);
    }

    /**
     * @param string $weight
     * @return mixed
     */
    public function setWeight($weight)
    {
        return $this->setData(self::WEIGHT, $weight);
    }

    /**
     * @param string $orderTotal
     * @return mixed
     */
    public function setOrderTotal($orderTotal)
    {
        return $this->setData(self::ORDER_TOTAL, $orderTotal);
    }

    /**
     * @param string $priceWithoutVat
     * @return mixed
     */
    public function setPriceWithoutVat($priceWithoutVat)
    {
        return $this->setData(self::PRICE_WITHOUT_VAT, $priceWithoutVat);
    }

    /**
     * @param int $fixedTimeDelivery
     * @return mixed
     */
    public function setFixedTimeDelivery($fixedTimeDelivery)
    {
        return $this->setData(self::FIXED_TIME_DELIVERY, $fixedTimeDelivery);
    }
}
