<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Observer\Customer;

class AddressDeleteAfter implements \Magento\Framework\Event\ObserverInterface
{
    /**
     * @var \Extensa\Speedy\Api\AddressRepositoryInterface
     */
    protected $addressRepository;

    /**
     * AddressDeleteAfter constructor.
     * @param \Extensa\Speedy\Api\AddressRepositoryInterface $addressRepository
     */
    public function __construct (
        \Extensa\Speedy\Api\AddressRepositoryInterface $addressRepository
    ) {
        $this->addressRepository = $addressRepository;
    }

    /**
     * Execute observer
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(
        \Magento\Framework\Event\Observer $observer
    ) {
        $customerAddress = $observer->getEvent()->getCustomerAddress();
        try {
            $speedyAddress = $this->addressRepository->getById(
                $customerAddress->getId()
            );

            if ($speedyAddress->getId()) {
                $this->addressRepository->delete($speedyAddress);
            }
        } catch (\Exception $e) {
        }
    }
}
