<?php
/**
 * @author Extensa Web Development Ltd. <support@extensadev.com>
 */

namespace Extensa\Speedy\Observer\Payment;

class MethodIsActive implements \Magento\Framework\Event\ObserverInterface
{
    /**
     * @var \Magento\Checkout\Model\Session
     */
    protected $checkoutSession;

    /**
     * MethodIsActive constructor.
     * @param \Magento\Checkout\Model\Session $checkoutSession
     */
    public function __construct (
        \Magento\Checkout\Model\Session $checkoutSession
    ) {
        $this->checkoutSession = $checkoutSession;
    }

    /**
     * Execute observer
     *
     * @param \Magento\Framework\Event\Observer $observer
     * @return void
     */
    public function execute(
        \Magento\Framework\Event\Observer $observer
    ) {
        if ($observer->getEvent()->hasQuote()) {
            $shippingMethod = $observer->getEvent()->getQuote()->getShippingAddress()->getShippingMethod();
            $paymentMethod = $observer->getEvent()->getMethodInstance()->getCode();

            if (strpos($shippingMethod, 'extensaspeedy') !== false
                && $observer->getEvent()->hasQuote()
                && $this->checkoutSession->hasExtensaSpeedy()
            ) {
                $session = $this->checkoutSession->getExtensaSpeedy();

                if (($paymentMethod == 'cashondelivery' && empty($session['cod'])) ||
                    ($paymentMethod != 'cashondelivery' && !empty($session['cod']))
                ) {
                    $observer->getEvent()->getResult()->setData('is_available', false);
                }
            }
        }
    }
}
