require([
    'jquery', // jquery Library
    'mageUtils',
    'Magento_Checkout/js/model/quote',
    'jquery/ui', // Jquery UI Library
    'jquery/validate', // Jquery Validation Library
    'mage/translate' // Magento text translate (Validation message translte as per language)
], function($, utils, quote) {
    function isNotSpeedyShipping(quote) {
        return (!utils.isEmpty(quote.shippingMethod()) && (quote.shippingMethod().carrier_code != 'extensaspeedy'));
    }

    $.validator.addMethod(
        'extensa-speedy-required-city', function (value) {
            return (!utils.isEmpty(value)) || isNotSpeedyShipping(quote);
        }, $.mage.__('Please enter a city.')
    );

    $.validator.addMethod(
        'extensa-speedy-required-quarter', function (value) {
            return ((!utils.isEmpty(value)
                && (!utils.isEmpty($('#extensa_speedy_quarter_id').val()) && ($('#extensa_speedy_quarter_id').val() !== '0'))
                || !utils.isEmpty($('#extensa_speedy_street').val())
                && (!utils.isEmpty($('#extensa_speedy_street_id').val()) && ($('#extensa_speedy_street_id').val() !== '0'))
                || !utils.isEmpty($('#extensa_speedy_additional_info').val())
                ) || (isNotSpeedyShipping(quote)));
        }, $.mage.__('Please enter a quarter or a street or an additional info.')
    );

    $.validator.addMethod(
        'extensa-speedy-required-street', function (value) {
            return (!utils.isEmpty(value)
                && (!utils.isEmpty($('#extensa_speedy_street_id').val()) && ($('#extensa_speedy_street_id').val() !== '0'))
                || !utils.isEmpty($('#extensa_speedy_quarter').val())
                && (!utils.isEmpty($('#extensa_speedy_quarter_id').val()) && ($('#extensa_speedy_quarter_id').val() !== '0'))
                || !utils.isEmpty($('#extensa_speedy_additional_info').val())
                ) || (isNotSpeedyShipping(quote));
        }, $.mage.__('Please enter a quarter or a street or an additional info.')
    );

    $.validator.addMethod(
        'extensa-speedy-required-street-no', function (value) {
            return (!utils.isEmpty($('#extensa_speedy_street').val())
                || !utils.isEmpty($('#extensa_speedy_street').val())
                && (!utils.isEmpty($('#extensa_speedy_street_id').val()) && ($('#extensa_speedy_street_id').val() !== '0'))
                && !utils.isEmpty(value)
                || !utils.isEmpty($('#extensa_speedy_quarter').val())
                && (!utils.isEmpty($('#extensa_speedy_quarter_id').val()) && ($('#extensa_speedy_quarter_id').val() !== '0'))
                && !utils.isEmpty($('#extensa_speedy_block_no').val())
                || !utils.isEmpty($('#extensa_speedy_additional_info').val())
                ) || (isNotSpeedyShipping(quote));
        }, $.mage.__('Please enter a number or an additional info.')
    );

    $.validator.addMethod(
        'extensa-speedy-required-block-no', function (value) {
            return (!utils.isEmpty($('#extensa_speedy_quarter').val())
                || !utils.isEmpty($('#extensa_speedy_quarter').val())
                && (!utils.isEmpty($('#extensa_speedy_quarter_id').val()) && ($('#extensa_speedy_quarter_id').val() !== '0'))
                && !utils.isEmpty(value)
                || !utils.isEmpty($('#extensa_speedy_street').val())
                && (!utils.isEmpty($('#extensa_speedy_street_id').val()) && ($('#extensa_speedy_street_id').val() !== '0'))
                && !utils.isEmpty($('#extensa_speedy_street_no').val())
                || !utils.isEmpty($('#extensa_speedy_additional_info').val())
                ) || (isNotSpeedyShipping(quote));
        }, $.mage.__('Please enter a block or an additional info.')
    );

    $.validator.addMethod(
        'extensa-speedy-required-address-1', function (value) {
            return (!utils.isEmpty(value)) || (isNotSpeedyShipping(quote));
        }, $.mage.__('Please enter an additional info.')
    );

    $.validator.addMethod(
        'extensa-speedy-required-office', function (value) {
            return (!utils.isEmpty(value)) || (isNotSpeedyShipping(quote)); // Validation logic here
        }, $.mage.__('Please enter a city and select an office.')
    );

    $.validator.addMethod(
        'extensa-speedy-speedyShippingMethod-required', function (value) {
            return (!utils.isEmpty(value)) || (isNotSpeedyShipping(quote)); // Validation logic here
        }, $.mage.__('Please calculate price.')
    );
});
